package cn.jecyp.baidupanopenapi.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSON;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import cn.jecyp.baidupanopenapi.pojo.dto.BaiduPanAccessTokenDTO;
import cn.jecyp.baidupanopenapi.pojo.dto.BaiduPanImageListDTO;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.io.IOException;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * @author cyp
 * @date 2023-07-31
 */
@Controller
@RequestMapping("/baidu/pan")
public class BaiduPanController {

    private String callback = "http://jecyp.nat300.top/openapi/baidu/pan/callback";

    private BaiduPanAccessTokenDTO accessToken = new BaiduPanAccessTokenDTO();
    {
        accessToken.setAccess_token("121.62804fe376fc92c5ac1ddd017c056edc.YmfpvVDzVgESpQp2wgw1yVfUd23vHbAIzhONRXp.795eYw");
        accessToken.setExpires_in("2592000");
        accessToken.setRefresh_token("122.ef800517f78d73f18acf5126b5659631.YaxBybnvqW6pUiTafTJCN5atxmnTaOu8U8QV6e-.f6WXCw");
        accessToken.setScope("basic netdisk");
    }


    @RequestMapping("/callback")
    public String callback(@RequestParam(name = "code", required = false, defaultValue = "code") String code,
                           @RequestParam(name = "state", required = false, defaultValue = "state") String state,
                           HttpServletRequest request){
        String contextPath = request.getContextPath();
        System.out.println("contextPath:"+contextPath);
        System.out.println("code="+code+",state="+state);
        String accessTokenBaseUrl = "https://openapi.baidu.com/oauth/2.0/token?grant_type=authorization_code&code={3}&client_id={0}&client_secret={1}&redirect_uri={2}";
        String accessTokenUrl = MessageFormat.format(accessTokenBaseUrl, "4DyoVFaBH2zoSAnpAowWS5w3P6FsgGM1", "ePuUZ64mq5qhNcRL7UpcRUhUoZVeHUZl",callback,code);
        String accessTokenRes = HttpUtil.get(accessTokenUrl);

        System.out.println("refreshTokenRes="+accessTokenRes);
        BaiduPanAccessTokenDTO baiduPanAccessTokenDTO = JSONUtil.toBean(accessTokenRes, BaiduPanAccessTokenDTO.class);
        System.out.println("refreshTokenRes bean="+baiduPanAccessTokenDTO);

//        String refreshTokenBaseUrl = "https://openapi.baidu.com/oauth/2.0/token?grant_type=refresh_token&refresh_token={2}&client_id={0}&client_secret={1}";
//        String refreshTokenUrl = MessageFormat.format(refreshTokenBaseUrl, "4DyoVFaBH2zoSAnpAowWS5w3P6FsgGM1", "ePuUZ64mq5qhNcRL7UpcRUhUoZVeHUZl",baiduPanAccessTokenDTO.getRefresh_token());
//        String refreshTokenRes = HttpUtil.get(refreshTokenUrl);
//        System.out.println("refreshTokenRes="+refreshTokenRes);
//        baiduPanAccessTokenDTO = JSONUtil.toBean(refreshTokenRes, BaiduPanAccessTokenDTO.class);
//        System.out.println("refreshTokenRes bean="+baiduPanAccessTokenDTO);

        return "index";
    }

    @RequestMapping("/login")
    @ResponseBody
    public void login(HttpServletResponse response) throws IOException {
        String baseUrl = "http://openapi.baidu.com/oauth/2.0/authorize?response_type=code&client_id={0}&redirect_uri={1}&scope=basic,netdisk&qrcode=1";
        String url = MessageFormat.format(baseUrl, "4DyoVFaBH2zoSAnpAowWS5w3P6FsgGM1", callback);
        System.out.println("url="+url);
        response.sendRedirect(url);
    }

    @RequestMapping("/imagesList")
    @ResponseBody
    public String imagesList(HttpServletResponse response) throws IOException, InterruptedException {

        String url = "http://pan.baidu.com/rest/2.0/xpan/file";
        BaiduPanImageListDTO baiduPanImageListDTO = new BaiduPanImageListDTO();
        baiduPanImageListDTO.setAccess_token(accessToken.getAccess_token());
        baiduPanImageListDTO.setParent_path(URLEncoder.encode("/电脑文件/手机图片/照片-杂", StandardCharsets.UTF_8));
        baiduPanImageListDTO.setPage(1);
        baiduPanImageListDTO.setNum(1);
        baiduPanImageListDTO.setWeb(1);
        Map<String, Object> stringObjectMap = BeanUtil.beanToMap(baiduPanImageListDTO);
        String res = HttpUtil.get(url, stringObjectMap);
        JSONObject json = JSONUtil.parseObj(res);
        JSONArray info = json.getJSONArray("info");
        JSONObject entries = info.get(0, JSONObject.class);
        JSONObject thumbs = entries.get("thumbs", JSONObject.class);
        String url3 = thumbs.getStr("url3");

        Thread.sleep(1000 * 10);
        res = HttpUtil.get(url, stringObjectMap);
        json = JSONUtil.parseObj(res);
        info = json.getJSONArray("info");
        entries = info.get(0, JSONObject.class);
        thumbs = entries.get("thumbs", JSONObject.class);
        String url32 = thumbs.getStr("url3");
        System.out.println(Objects.equals(url32, url3));
        System.out.println("imagesList="+res);
        return res;
    }

    @RequestMapping("/index")
    public String index(HttpServletResponse response) throws IOException {
        return "index";
    }

}
