package cn.jecyp.baidupanopenapi.pojo.dto;

import lombok.Data;

import java.io.Serializable;

/**
 * 百度判断返回的accessToken对象
 * @author cyp
 * @date 2023-07-31
 */
@Data
public class BaiduPanAccessTokenDTO implements Serializable {

    /**
     * 获取到的Access Token是调用网盘开放API访问用户授权资源的凭证。
     */
    private String access_token;

    /**
     *  Token的有效期，单位为秒。
     */
    private String expires_in;

    /**
     * 用于刷新 Access Token, 有效期为10年。
     */
    private String refresh_token;

    /**
     * Access Token 最终的访问权限，即用户的实际授权列表。
     */
    private String scope;
}
