package cn.jecyp.baidupanopenapi.pojo.dto;

import lombok.Data;

/**
 * @author cyp
 * @date 2023-07-31
 */
@Data
public class BaiduPanImageListDTO {

    /**
     * 是 URL参数 本接口固定为imagelist
     */
    private String method = "imagelist";

    /**
     * 是 URL参数	接口鉴权参数
     */
    private String access_token;

    /**
     * 否	URL参数	目录名称，以/开头的绝对路径, 默认为/ 路径包含中文时需要UrlEncode编码
     */
    private String parent_path;

    /**
     * 	否	URL参数	页码，从1开始， 如果不指定页码，则为不分页模式，返回所有的结果 如果指定page参数，则按修改时间倒序排列
     */
    private Integer page;

    /**
     * 否	URL参数	一页返回的图片数，默认值为1000，建议最大值不超过1000
     */
    private Integer num;

    /**
     * 否 URL参数	排序字段：time按修改时间排序，name按文件名称排序(注意，此处排序是按字符串排序的，如果用户有剧集排序需求，需要自行开发)，size按文件大小排序，默认为time
     */
    private String order;

    /**
     * 否	URL参数	0为升序，1为降序，默认为1
     */
    private Integer desc;

    /**
     * 	否	URL参数	是否需要递归，0为不需要，1为需要，默认为0.递归是指：当目录下有文件夹，使用此参数，可以获取到文件夹下面的图片
     */
    private Integer recursion;

    /**
     * 否	URL参数	为1时返回图片缩略图
     */
    private Integer web;
}
